'nssb2
'narrowband ssb
'DF6NM, 7.6.04
'ex nssb1 nvox1e

'optional commandline parameters (with default values):
' /xp /rx /tx /period=24 /window=1.25 /scale=1.0
' /input=audio\in.dat /output=audio\out.dat

  DEFINT A-Z
  PRINT "nssb2  - Narrowband SSB Voice Transmission by DF6NM "
  cmd$ = LCASE$(COMMAND$)
  'cmd$ = "/xp"
  'cmd$ = "/xp /tx /factor=8"

  factor = 3: pmin = 24: win! = 1.25: fc! = 1750: scale! = 1!
  mode = 1: xp$ = ""
  path$ = "audio\"
  infile$ = path$ + "in.dat"
  outfile$ = path$ + "out.dat"
 
  p = INSTR(cmd$, "/xp"): IF p > 0 THEN xp$ = "cmd /c start "
  p = INSTR(cmd$, "/tx"): IF p > 0 THEN mode = 2
  p = INSTR(cmd$, "/rx"): IF p > 0 THEN mode = 1
  p = INSTR(cmd$, "/period="): IF p > 0 THEN pmin = VAL(MID$(cmd$, p + 8))
  p = INSTR(cmd$, "/factor="): IF p > 0 THEN factor = VAL(MID$(cmd$, p + 8))
  p = INSTR(cmd$, "/freq="): IF p > 0 THEN fc! = VAL(MID$(cmd$, p + 6))
  p = INSTR(cmd$, "/window="): IF p > 0 THEN win! = VAL(MID$(cmd$, p + 8))
  p = INSTR(cmd$, "/scale="): IF p > 0 THEN scale! = VAL(MID$(cmd$, p + 7))
  p = INSTR(cmd$, "/input=")
  IF p > 0 THEN
   f$ = LTRIM$(MID$(cmd$, p + 7))
   p2 = INSTR(f$, " "): IF p2 = 0 THEN p2 = LEN(f$) ELSE p2 = p2 - 1
   infile$ = LEFT$(f$, p2)
  END IF
  p = INSTR(cmd$, "/output=")
  IF p > 0 THEN
   f$ = LTRIM$(MID$(cmd$, p + 8))
   p2 = INSTR(f$, " "): IF p2 = 0 THEN p2 = LEN(f$) ELSE p2 = p2 - 1
   outfile$ = LEFT$(f$, p2)
  END IF
 
  lw = 2
  DIM w&(lw - 1)
 
'  PRINT "factor="; factor; "period="; pmin; "samples window="; win!; "center= "; fc!; "Hz scale= "; scale!
'  PRINT "input="; infile$; " output="; outfile$
  PRINT "press return for RX/TX, b or f to change bandwidth or center freq, q to quit"

 WHILE mode
 
  f0 = fc - 1500 / factor: f1 = fc! - 1050 / factor: f2 = fc! + 1050 / factor
  dec$ = LTRIM$(STR$(4 * factor))
  fc$ = LTRIM$(STR$(fc!))
  IF mode = 1 THEN    'RX
   LOCATE , 1: PRINT "        RECEIVING "; f1; "to"; f2; "-> 400 to 2500 Hz      ";
   pin = pmin: pout = pin * factor
   bufoffs = ((pout - pin + lw) \ 64 + 1) * 64
   SHELL xp$ + "sndinput /dec=" + dec$ + " /fc=" + fc$ + " /chunk=512 /maxsize=8192 /of=" + infile$
   SHELL xp$ + "sndoutpt /dec=4 /fc=1450 /chunk=512 /fn=" + outfile$
  END IF
  IF mode = 2 THEN
   LOCATE , 1: PRINT "        TRANSMITTING  400 to 2500 ->"; f1; "to"; f2; "Hz   ";
   pout = pmin: pin = pout * factor   'tx
   bufoffs = ((pin * factor + lw) \ 64 + 1) * 64
   SHELL xp$ + "sndinput /dec=4 /fc=1450 /chunk=512 /maxsize=8192 /of=" + infile$
   SHELL xp$ + "sndoutpt /dec=" + dec$ + " /fc=" + fc$ + "  /chunk=512 /fn=" + outfile$
 
  END IF
 
  outfiletmp$ = LEFT$(outfile$, LEN(outfile$) - 3) + "tmp"
  infiletmp$ = LEFT$(infile$, LEN(infile$) - 3) + "tmp"

  pio = pin - pout
  lw = pmin * factor * win!
  'bufoffs = ((pin + lw) \ 64 + 1) * 64
  'bufoffs = ((pmin * factor + lw) \ 64 + 1) * 64
  'bufoffs = ((ABS(pio) * factor + lw) \ 64 + 1) * 64
  buflen = bufoffs * 2
  outbuflen = 64
  ain$ = "": aout$ = ""
  umax = 20000 '6500 '22700

  ERASE w&
  DIM w&(lw - 1)
  pi! = 4! * ATN(1!)
  FOR t = 0 TO lw - 1
   w&(t) = 1024! * scale! * SIN(pi! * (t + .5) / lw)
  NEXT t
 
  dt1 = 0
  tin1 = 0
  WHILE 1
   dt = dt1
   tin = tin1
   ar& = 0: ai& = 0
   'PRINT tout; tin1; dt1,
   WHILE dt >= 0
    IF 4 * tin + 4 >= LEN(ain$) THEN
     GOSUB writeoutbuf
     GOSUB fillbuf
     IF i$ <> "" THEN GOTO keypressed
    END IF
    'PRINT tin1; tin; LEN(ain$); "*";  ' ar&; ai&,
    ar& = ar& + w&(dt) * CVI(MID$(ain$, 4 * tin + 1, 2))
    ai& = ai& + w&(dt) * CVI(MID$(ain$, 4 * tin + 3, 2))
    tin = tin + pio
    dt = dt - pout
   WEND
   dt1 = dt1 + 1
   tin1 = tin1 + 1
   IF dt1 >= lw THEN
    dt1 = dt1 - pout
    tin1 = tin1 + pio
    'PRINT tin1; tin; LEN(ain$); "<";
   END IF

   ar& = ar& \ 1024
   IF ar& > umax THEN ar& = umax
   IF ar& < -umax THEN ar& = -umax
   ai& = ai& \ 1024
   IF ai& > umax THEN ai& = umax
   IF ai& < -umax THEN ai& = -umax
   aout$ = aout$ + MKI$(ar&) + MKI$(ai&)
  
   'phi! = phi! + pi! * .05
   'aout$ = aout$ + MKI$(umax * SIN(phi!)) + MKI$(umax * COS(phi!))
  
   IF LEN(aout$) > outbuflen * 4 THEN GOSUB writeoutbuf
 
  WEND

keypressed:
  SHELL "sndinput /quit"
  SHELL "sndoutpt /quit"
  ON ERROR GOTO errhandler
   KILL infile$
   KILL infiletmp$
   KILL outfile$
   KILL outfiletmp$
  ON ERROR GOTO 0
  t2! = TIMER + 1!: IF t2! > 86400! THEN t2! = t2! - 86400!
  WHILE TIMER < t2!: WEND
 
  IF i$ = CHR$(13) THEN mode = 3 - mode
  IF i$ = "q" THEN mode = 0
  IF i$ = "b" THEN
   LOCATE , 1: INPUT ; " bandwidth factor "; factor
  END IF
  IF i$ = "f" THEN
   LOCATE , 1: INPUT ; " center frequency "; fc!
  END IF

 WEND

 PRINT
 SYSTEM

 END


fillbuf:
  ' shift pointers
  IF LEN(ain$) >= 4 * bufoffs THEN
   bufcut = LEN(ain$) \ 4 - bufoffs
   tin = tin - bufcut
   tin1 = tin1 - bufcut
   ain$ = RIGHT$(ain$, LEN(ain$) - bufcut * 4)
  END IF
  ' try to get next file
  WHILE LEN(ain$) < 4 * buflen
   flag = 0
   WHILE flag = 0   'waiting loop
    GOSUB tryrenameoutfile
    ON ERROR GOTO errhandler
     flag = 1: OPEN infile$ FOR INPUT AS 1
    ON ERROR GOTO 0
    i$ = INKEY$: IF i$ <> "" THEN RETURN
   WEND
   CLOSE 1
   OPEN infile$ FOR BINARY AS 1
    ain$ = ain$ + INPUT$(LOF(1), #1)
    'PRINT
    LOCATE , 1: PRINT LEN(ain$);
    'PRINT bufcut
   CLOSE 1
   KILL infile$
  WEND
 RETURN

writeoutbuf:
  IF LEN(aout$) > 0 THEN
   'OPEN outfiletmp$ FOR APPEND AS 2  'does not work
   ' PRINT #2, aout$;
   OPEN outfiletmp$ FOR BINARY AS 2
    PUT #2, LOF(2) + 1, aout$
   CLOSE 2
   aout$ = ""
  END IF
  GOSUB tryrenameoutfile
 RETURN

tryrenameoutfile:
   ON ERROR GOTO errhandler
    NAME outfiletmp$ AS outfile$
   ON ERROR GOTO 0
  RETURN

errhandler:
  IF ERR = 53 THEN flag = 0  'file not found
 RESUME NEXT

